(function () {
    const isBankSelected = () => {
        return !!$('[name="payment-method"]:visible').filter(":checked").length;
    };

    const isOptionSelected = () => {
        return !!$('[name="payment-category"]').filter(":checked").length || !!$('[name="payment-method"]:visible').filter(":checked").length
    };

    function prettyAlert(message, status) {
        swal(message, "", status);
    }

    const validator = () => {
        const attrs = $('.attribute:visible');
        let  result = true;
        attrs.each(function () {
            if (!$(this).val() && $(this).prop('required')) {
                $(this).addClass('invalid');
                prettyAlert("Required field is empty!", "error");
                result = false;
                return;
            }

            if ($(this).val() && !(new RegExp($(this).data('regexp') + '')).test($(this).val())) {
                $(this).addClass('invalid');
                prettyAlert("Invalid value of field!", "error");
                result = false;
                return;
            }
        });
        return result;
    }

    $(function() {
        let $paymentConfirmationButton = $('#place_order');

        $('.payment-category-radio').on('click', function(){
            $('.payment-method-radio').add('.payment-method-radio_2').prop('checked', false);
        });

        $('.attribute').on('click', function() {
            $(this).removeClass('invalid');
        });

        $('.payment-method-radio_2').on('change', function () {
            $('.payment-category-radio').prop('checked', false);
            if ($(this).is(':checked')) {
                ($(this).siblings('.attribute-list')).children('.attribute').prop('disabled', false);
            }
        });

        $('.payment-method-radio').on('change', function () {
            $('.payment-category-radio').parent().prop('checked', false);
            ($('.attribute')).prop('disabled', 'disabled');
            if ($(this).is(':checked')) {
                ($(this).siblings('.attribute-list')).children('.attribute').prop('disabled', false);
            }
        });

        $paymentConfirmationButton.on('click', function(event) {
            let $canProceed = true;

            if (!isOptionSelected()) {
                prettyAlert("Please select payment method before continuing!", "error");
                $canProceed = false;
            }

            if ($canProceed && !isBankSelected()) {
                prettyAlert("Please select payment method before continuing!", "error");
                $canProceed = false;
            }

            if ($canProceed && !validator()) {
                $canProceed = false;
            }

            if (!$canProceed) {
                event.preventDefault();
                event.stopPropagation();
            }
        });
    });
})();